#!/usr/bin/perl -w
# Fasta 形式の cDNA 配列を MacClade Nexus 形式に変換する
# perl FasToNex_cDNA.pl infile

use strict;
use warnings;

my $infile = "$ARGV[0]";
my $outfile = $infile.".nex";

my $name = "";
my $seq = "";
my $whitespace = '';
my $space = "";

my $LineMilestone = 0;

my @inFileCont =  ( );
my @SpListArray = ( );

my %efas = ( );

open(INFILE,"$infile");
@inFileCont = <INFILE>;
close INFILE;

# 各ファイルからファスタ形式を取り込んでハッシュに格納する．

foreach my $line (@inFileCont) {
  if ($line =~ /^>/) {
  
    if ($LineMilestone == 0) {
      chomp($line);
      $name = $line;
      $LineMilestone = 1;      
    } else {
      $name =~ s/>//g;
      push(@SpListArray,$name);
      $efas{$name} = $seq;
      $name = '';
      $seq = '';
      chomp($line);
      $name = $line;    
    }
  } else {
    chomp($line);
    $seq .= $line;
  }
}
$name =~ s/>//g;
push(@SpListArray,$name);
$efas{$name} = $seq;

    

#プリントアウト
open(OUT,">$outfile");

print OUT 
"#NEXUS 

BEGIN DATA;
	DIMENSIONS  NTAX=".($#SpListArray+1)." NCHAR=".length($seq).";
	FORMAT DATATYPE=DNA  MISSING=? GAP=- ;

MATRIX\n";

foreach my $pname (@SpListArray) {
  chomp($pname);
  $space = " " x (50-length($pname));
  print OUT "$pname     $space $efas{$pname}\n";
}
  
print OUT ";
END;


BEGIN CODONS;
	CODONPOSSET * CodonPositions = 
		1:1-".(length($seq)-2)."\\3,\n";
print OUT "		2:2-".(length($seq)-1)."\\3,\n";
print OUT "		3:3-".length($seq)."\\3 ".length($seq).";\n";

print OUT "	CODESET  * UNTITLED = Universal: all ;
END;


BEGIN ASSUMPTIONS;
	OPTIONS  DEFTYPE=unord PolyTcount=MINSTEPS ;
END;


BEGIN MacClade;
	Version 4.0  87;
	LastModified -922103409;
	FileSettings editor  '0' '0' '1' '1';
	Singles 100;
	Editor 00011001111111100100010010 '4' '12' Geneva '9' '294' '1' all;
	EditorPosition  '321' '487' '947' '1781';
	TreeWindowPosition  '46' '6' '1375' '2510';
	ListWindow Characters closed Geneva '9' '50' '10' '129' '406' 000;
	ListWindow Taxa closed Geneva '9' '50' '10' '129' '490' 100000000;
	ListWindow Trees closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow TypeSets closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow WtSets closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow ExSets closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow CharSets closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow TaxSets closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow CharPartitions closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow CharPartNames closed Geneva '9' '50' '10' '276' '490' ;
	ListWindow WtSets closed Geneva '9' '50' '10' '276' '490' ;
	ChartWindowPosition  '52' '30' '1358' '2500';
	StateNamesSymbols closed Geneva '9' '10' '50' '30' '148' '220';
	WindowOrder  Data;
	OtherSymbols &/ 00 ?-;
	Correlation  '0' '0' '1000' '0' '0' 10011010;
	Salmo 00000001;
	EditorFile  '2';
	ExportHTML _ MOSS  '100' 110000;
	PrettyPrint 10;
	EditorToolsPosition  '1249' '46' '115' '165';
	TreeWindowProgram 10;
	TreeWindow 0000;
	Continuous  '0' '3' 1;
	Calculations 0000001;
	SummaryMode  '0' '0' 0;
	Charts  Geneva '9' (normal) 0010;
	NexusOptions  '0' '0' '50' 001011001;
	TipLabel  '1';
	TreeFont  Geneva '9' (normal);
	TreeShape  1.0 1.0 1110;
	TraceLabels 0101;
	ChartColors  '0' '0' '65535' '9' '0' 1;
	ChartBiggestSpot 1;
	ChartPercent 10;
	ChartBarWidth  '10' 1;
	ChartVerticalAxis 10101;
	ChartMinMax  '0';
	TraceAllChangesDisplay  '1' 1;
	BarsOnBranchesDisplay  '0' '0' '60000' '10000' '10000' '10000' '10000' '60000' '65000' '65000' '65000' '6' '1' 0000101;
	ContinuousBranchLabels 0;
	AllStatesBranchLabels 1;
	IndexNotation  '2' 1;
	PrintTree  10.00 '2' '2' '2' '2' '2' '2' '2' '2' '2' '2' '2' Geneva '9' (normal) Geneva '10' (normal) Geneva '9' (normal) Geneva '9' (normal) Geneva '9' (bold ) Geneva '9' (normal) Geneva '9' (normal) '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '0' '1' '1' '1' '1' '0' '13' '-39' '4' '-40' '0' '1' '2' '1' '8' '0' '0' '0' '2' 1000111000000000000100000111000;
	MatchChar 00 .;
	EntryInterpretation 01;
	ColorOptions 00;
	TreeTools  '0' '5' '4' '0' '10' '4' '0' 00100111111101110;
	EditorTools  '0' '0' '0' '1000' '0' '0' '6' '3' '1' 100010101110011;
	PairAlign  '2' '2' '3' '2' '1' '1' '2' '1' '3' 1010;
	BothTools  '1';
END;


";

print OUT "\n";

close OUT;

# outfile の改行コードを Unix から　Mac する．
system ("perl -i -pe 's/\n/\r/g' $outfile");


exit;